/*
 * ********************************************************************************************************************
 *
 *               iFHS7.
 *              ;BBMBMBMc                  rZMBMBR              BMB
 *              MBEr:;PBM,               7MBMMEOBB:             BBB                       RBW
 *     XK:      BO     SB.     :SZ       MBM.       c;;     ir  BBM :FFr       :SSF:    ;xBMB:r   iuGXv.    i:. iF2;
 *     DBBM0r.  :D     S7   ;XMBMB       GMBMu.     MBM:   BMB  MBMBBBMBMS   WMBMBMBBK  MBMBMBM  BMBRBMBW  .MBMBMBMBB
 *      :JMRMMD  ..    ,  1MMRM1;         ;MBMBBR:   MBM  ;MB:  BMB:   MBM. RMBr   sBMH   BM0         UMB,  BMB.  KMBv
 *     ;.   XOW  B1; :uM: 1RE,   i           .2BMBs  rMB. MBO   MBO    JMB; MBB     MBM   BBS    7MBMBOBM:  MBW   :BMc
 *     OBRJ.SEE  MRDOWOR, 3DE:7OBM       .     ;BMB   RMR7BM    BMB    MBB. BMB    ,BMR  .BBZ   MMB   rMB,  BMM   rMB7
 *     :FBRO0D0  RKXSXPR. JOKOOMPi       BMBSSWBMB;    BMBB:    MBMB0ZMBMS  .BMBOXRBMB    MBMDE RBM2;SMBM;  MBB   xBM2
 *         iZGE  O0SHSPO. uGZ7.          sBMBMBDL      :BMO     OZu:BMBK,     rRBMB0;     ,EBMB  xBMBr:ER.  RDU   :OO;
 *     ,BZ, 1D0  RPSFHXR. xWZ .SMr                  . .BBB
 *      :0BMRDG  RESSSKR. 2WOMBW;                   BMBMR
 *         i0BM: SWKHKGO  MBDv
 *           .UB  OOGDM. MK,                                          Copyright (c) 2015-2019.  斯伯坦机器人
 *              ,  XMW  ..
 *                  r                                                                     All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.sybotan.android.demo.activities

import android.os.Bundle
import android.util.Log
import android.widget.Toast
import cn.sagacloud.android.cadengine.FloorScene
import cn.sagacloud.cadengine.HttpDownloadMap
import com.sybotan.android.demo.R
import com.sybotan.android.graphy.events.SGraphyViewMoveEvent
import kotlinx.android.synthetic.main.activity_graphy.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.jetbrains.anko.doAsync
import org.jetbrains.anko.uiThread

import android.content.Intent
import android.view.View
import cn.sagacloud.android.cadengine.items.PointItem
import cn.sagacloud.android.cadengine.items.QrcodeItem
import cn.sagacloud.android.cadengine.items.SpaceNameItem
import cn.sagacloud.android.cadengine.items.TunableSpaceItem
import cn.sagacloud.android.cadengine.types.Point
import cn.sagacloud.android.cadengine.types.Space
import cn.sagacloud.android.cadengine.types.TunableSpace
import com.google.gson.Gson
import com.sybotan.android.demo.bean.result.Position
import com.sybotan.android.demo.bean.result.ProblemsModel
import com.sybotan.android.demo.bean.result.QrcodeModel
import com.sybotan.android.demo.bean.result.SpaceJobModel
import com.sybotan.android.demo.viewmodel.GraphyVM
import com.zbar.lib.CaptureActivity


class GraphyActivity : BaseActivity() {
    companion object {
        private val TAG = GraphyActivity::class.java.name
        private val REQUEST_CODE_SCAN = 0x0000 // 扫描二维码
    }

    lateinit var graphyVM: GraphyVM

    //实际距离
    val distance = 1800f

    //缩放后的同比例距离
    var realDistance = 0f

    val scene = FloorScene()
    val gson = Gson()

    //    val path = "base/cbde057b91e711eb9901557a780001bf.jsonz"
//    val path = "base/ebd53bb00d3511eb9a1db95f725712e8.jsonz"
//    val path = "base/a4e671ec8b8111eb9a520dc30d098a92.jsonz"
//    val path = "base/0764ad79555d11ebab557bd2e22cfb56.jsonz"
    val path = "base/05d5b9e6c8c411eb8437353008b31107.jsonz"

    @Subscribe
    fun test(msg: SGraphyViewMoveEvent) {
        Log.d(TAG, "msg=$msg")

    } // test()

    /**
     * 创建Activity时的回调函数
     *
     * @param   savedInstanceState
     */
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_graphy)
        // 注册eventbus
        EventBus.getDefault().register(this)

        graphyView.scene = scene

        /** 开启异步 */
        doAsync {
            val downloadGZIPMap = HttpDownloadMap.downloadGZIPMap(path)
            if (downloadGZIPMap != null) {
                scene.loadData(downloadGZIPMap!!)
            }
            /** 主线程处理ui */
            uiThread {
                /** 适应屏幕大小 */
                graphyView.fitSceneToView()
//                graphyView.defaultScale = graphyView.scale
                /** 限定移动范围不超出屏幕 */
//                graphyView.moveRange()
                graphyView.post {
                    Log.e("viewW", graphyView.width.toString())
                }

                Log.e("viewH", graphyView.measuredHeight.toString())
            }
        }
        /** 点击监听 */
        initListener()
        /** 图形点击-poc业务 */
        initSingleTopUp()
        /** 网络请求回调处理 */
        initViewModel()


        return
    } // Function onCreate()

    /**
     * 图形点击事件
     * */
    private fun initSingleTopUp() {
        scene.setOnSingleTopUp(object : FloorScene.OnSingleTopUp {
            override fun onSingUp(x: Float, y: Float) {
                //选中空间完毕界面逻辑
                if (scene.mapType.equals("space")) {
                    spaceStructure.visibility = View.VISIBLE
                    spaceName.text = scene.choseSpace!!.data.localName
                    graphyVM.getProblem(scene.choseSpace)
                    graphyVM.getQrcode(scene.choseSpace)
                    //未选中空间
                } else if (scene.mapType.equals("nothing")) {
                    spaceStructure.visibility = View.GONE
                    qrcodeLl.visibility = View.GONE
                    for (item in scene.pointItemList) {
                        scene.removeItem(item)
                    }
                    scene.pointItemList.clear()
                    for (item in scene.qrcodeItemList) {
                        scene.removeItem(item)
                    }
                    scene.qrcodeItemList.clear()
                }

                //打点业务
                if ("dot".equals(scene.type)) {
                    scene.type = "normal"
                    addDot.alpha = 1f
                    graphyVM.addProblem(scene.choseSpace, x, y)
                    return
                }

                //查看模式下，判断问题点选中逻辑
                if ("normal".equals(scene.type)) {
                    realDistance = distance * scene.defaultPointScale / graphyView.scale
                    for (point in scene.pointItemList) {
                        val sqrt = Math.sqrt(
                            Math.pow(
                                Math.abs(x - point.data.mX).toDouble(),
                                2.0
                            ) + Math.pow(Math.abs(y - point.data.mY).toDouble(), 2.0)
                        ).toInt()
                        if (sqrt < realDistance) {
                            showDotDetail(point)
                            break
                        }
                    }
                    return
                }

                //绑定二位码业务
                if ("qrcode".equals(scene.type)) {
                    qrcodeLl.visibility = View.VISIBLE
                    qrcodeLocation.setText("(${scene.point.mX},${scene.point.mY})")
                    spaceStructure.visibility = View.GONE

                }
            }
        })
    }

    /**
     * 页面全部监听事件
     */
    private fun initListener() {
        //nfc点击监听
        nfc.setOnClickListener { Toast.makeText(this, "正在开发中，敬请期待", Toast.LENGTH_SHORT).show() }

        //checkBox
        modelCheckBox.setOnCheckedChangeListener { buttonView, isChecked ->
            if (isChecked) {
                modelSubmit.isEnabled = true
                modelSubmit.alpha = 1f
            } else {
                modelSubmit.isEnabled = false
                modelSubmit.alpha = 0.3f
            }
        }

        //设置空间的任务状态完成
        modelSubmit.setOnClickListener {
            graphyVM.setJob(scene.choseSpace, codeEdit.text.toString())
        }

        //打点按钮
        addDot.setOnClickListener {
            scene.type = "dot"
            addDot.alpha = 0.3f
        }

        //绑定二维码按钮
        qrcode.setOnClickListener {
            scene.type = "qrcode"
            qrcodeLl.visibility = View.VISIBLE
            spaceStructure.visibility = View.GONE
        }

        //取消绑定二维码
        qrcodeCancel.setOnClickListener {
            qrcodeLl.visibility = View.GONE
            spaceStructure.visibility = View.VISIBLE
            scene.type = "normal"
            scene.item?.let { it1 -> scene.removeItem(it1) }
        }

        //下一步
        qrcodeNext.setOnClickListener {
            val intent = Intent(this@GraphyActivity, CaptureActivity::class.java)
            startActivityForResult(intent, REQUEST_CODE_SCAN)
        }
    }

    /**
     * 初始化viewModel
     */
    private fun initViewModel() {
        graphyVM = GraphyVM({ name, params ->
            when (name) {

                /** 查询空间和任务 */
                GraphyVM.SPACE_JOB -> {
                    for (item in scene.tunableSpaceList) {
                        scene.removeItem(item)
                    }
                    scene.tunableSpaceList.clear()

                    val list = params as (List<SpaceJobModel>)
                    for (model in list) {
                        if (!model.outline.isEmpty()) {
                            val space = Space()
                            space.outLine = model.outline.get(0)
                            space.name = model.name
                            val nameItem = SpaceNameItem(space)
                            nameItem.zOrder = 99999f
                            nameItem.isVisible = scene.isShowSpace
                            scene.spaceNameList.add(nameItem)
                            scene.addItem(nameItem)

                            val tunableSpace = TunableSpace()
                            tunableSpace.outLine = model.outline.get(0)
                            tunableSpace.name = model.name
                            tunableSpace.jobStatus = model.job
                            tunableSpace.id = model.id
                            tunableSpace.localName = model.localName
                            val item = TunableSpaceItem(tunableSpace, null)
                            item.isVisible = true
                            item.zOrder = 99996f
                            scene.tunableSpaceList.add(item)
                            scene.addItem(item)
                        }
                    }
                }
                /** 添加空间核查问题 */
                GraphyVM.ADD_PROBLEM -> {
                    Toast.makeText(this, "记录成功", Toast.LENGTH_SHORT).show()
                    graphyVM.getProblem(scene.choseSpace)
                    graphyVM.getSpaceJob()
                }

                /** 查询空间核查问题 */
                GraphyVM.GET_PROBLEM -> {
                    for (item in scene.pointItemList) {
                        scene.removeItem(item)
                    }
                    scene.pointItemList.clear()
                    var list = params as ArrayList<ProblemsModel>
                    for (model in list) {
                        val point = Point()
                        var position = gson.fromJson(model.position, Position::class.java)
                        point.mX = position.x.toFloat()
                        point.mY = position.y.toFloat()
                        point.id = model.id
                        var item = PointItem(point, null, scene.defaultPointScale)
                        item.isVisible = true
                        item.zOrder = 100000f
                        scene.pointItemList.add(item)
                        scene.addItem(item)
                    }
                }

                /** 关闭空间核查问题 */
                GraphyVM.CLOSE_PROBLEM -> {
                    graphyVM.getProblem(scene.choseSpace)
                }

                /** 绑定二维码 */
                GraphyVM.BIND_QECODE -> {
                    Toast.makeText(this, "绑定成功", Toast.LENGTH_SHORT).show()
                    scene.type = "normal"
                    qrcodeLl.visibility = View.GONE
                    spaceStructure.visibility = View.VISIBLE
                    scene.removeItem(scene.item!!)
                    scene.qrcodeItemList.clear()
                    graphyVM.getQrcode(scene.choseSpace)
                }

                /** 查询对象绑定的二维码 */
                GraphyVM.GET_QECODE -> {
                    val models = params as ArrayList<QrcodeModel>
                    for (model in models) {
                        val point = Point()
                        var position = gson.fromJson(model.position, Position::class.java)
                        point.mX = position.x.toFloat()
                        point.mY = position.y.toFloat()

                        var item = QrcodeItem(point, null, scene.defaultPointScale)
                        item.isVisible = true
                        item.zOrder = 100000f
                        scene.qrcodeItemList.add(item)
                        scene.addItem(item)
                    }
                }

                /** 设置空间的任务状态(新建和修改) */
                GraphyVM.SET_JOB -> {
                    Toast.makeText(this, "核查成功", Toast.LENGTH_SHORT).show()
                    refreshAll()
                    graphyVM.getSpaceJob()
                }

                /** 设置空间核查问题的信息和状态 */
                GraphyVM.SET_PROBLEM -> {
                    graphyVM.getSpaceJob()
                }
            }
        }, this)
        graphyVM.getSpaceJob()
    }

    /**
     * 重置空间界面
     */
    private fun refreshAll() {
        for (item in scene.pointItemList) {
            scene.removeItem(item)
        }
        scene.pointItemList.clear()

        for (item in scene.tunableSpaceList) {
            scene.removeItem(item)
        }
        scene.tunableSpaceList.clear()

        for (item in scene.qrcodeItemList) {
            scene.removeItem(item)
        }
        scene.qrcodeItemList.clear()

        spaceStructure.visibility = View.GONE
        scene.type = "normal"
        modelCheckBox.isChecked = false
        codeEdit.setText("")
    }

    /**
     * 显示点位信息框
     */
    private fun showDotDetail(point: PointItem) {
        spaceStructure.visibility = View.GONE
        quesDetail.visibility = View.VISIBLE
        quesTv.setText(
            "这是描述问题的文本，左侧是拍照图片。" +
                    "\nx轴:${point.data.mX}" +
                    "\ny轴:${point.data.mY}" +
                    "\n点击下方“问题已解决”按钮后可关闭该问题点。"
        )
        //问题已解决按钮
        quesSubmit.setOnClickListener {
            graphyVM.closeProblem(point, scene.choseSpace)
            spaceStructure.visibility = View.VISIBLE
            quesDetail.visibility = View.GONE
            scene.pointItemList.remove(point)
            scene.removeItem(point)
            if (scene.pointItemList.isEmpty()) {
                for (item in scene.tunableSpaceList) {
                    scene.removeItem(item)
                }
            }
            graphyVM.getSpaceJob()
        }
    }

    /**
     * 扫码返回uuid
     */
    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            REQUEST_CODE_SCAN ->                 // 扫描二维码回传
                if (resultCode == RESULT_OK) {
                    if (data != null) {
                        //获取扫描结果
                        val bundle = data.extras
                        val result = bundle.getString(CaptureActivity.EXTRA_STRING)
                        Log.e("tag", "扫描结果：$result")
                        graphyVM.bindQrcode(
                            scene.choseSpace,
                            result,
                            scene.point,
                            qrcodeEdit.text.toString()
                        )
                    }
                }
            else -> {
            }
        }
    }


} // Class GraphyActivity
